{% extends "base.html" %}

{% block content %}
    <script type="text/javascript">
        $(document).ready(function () {
            $('#show_password').on('show.bs.modal', function (event) {
                let button = $(event.relatedTarget); // Button that triggered the modal
                let password = button.data('password'); // Extract info from data-* attributes
                let modal = $(this);
                modal.find('#showpasswordLabel').text(password);
            });
        });
    </script>
    <h4>Remote Access Configuration</h4>
    <hr>
    {% if ra_config %}
        <table class="table table-sm">
            <thead class="thead-dark">
            {% for row in ra_config %}
                <tr>
                    <th>Remote Access ID</th>
                    <td>{{ row.id }}</td>
                </tr>
                <tr>
                    <th>Time Created</th>
                    <td>{{ row.time_created }}</td>
                </tr>
                <tr>
                    <th>VPN Type</th>
                    <td>{% if row.l3 %}Layer 3 VPN {% else %}Layer 2 VPN{% endif %}</td>
                </tr>
                <tr>
                    <th>A: Public IP</th>
                    <td>{{ row.a_public_ip }}</td>
                </tr>
                <tr>
                    <th>A: Public Port</th>
                    <td>{{ row.a_public_port }}</td>
                </tr>
                <tr>
                    <th>A: Public Key</th>
                    <td>{{ row.a_public_key }}</td>
                </tr>
                <tr>
                    <th>A: Tunnel CIDR</th>
                    <td>{{ row.a_tunnel_cidr }}</td>
                </tr>
                <tr>
                    <th>A: Local Networks</th>
                    <td>{{ row.a_local_networks }}</td>
                </tr>
                {% if row.dns1 or row.dns2 %}
                    <tr>
                        <th>DNS</th>
                        <td>{{ row.dns1 }}, {{ row.dns2 }}</td>
                    </tr>
                {% endif %}
                <tr>
                    <th>Associated User</th>
                    <td>{{ row.user }}</td>
                </tr>
                <tr>
                    <th>Wireguard Interface Status</th>
                    <td>{{ wg_state }}</td>
                </tr>
                <tr>
                    <th>Start / Stop RA Connection</th>
                    <td>
                        <div>
                            <form class="float-left mr-3"
                                  action="{{ url_for("url.start_stop", what="ra", value="start") }}" method="post">
                                <button class="btn btn-success btn-sm" type="submit" value="Start">
                                    <i class="fas fa-fw fa-play-circle"></i>
                                </button>
                            </form>
                        </div>
                        <div>
                            <form action="{{ url_for("url.start_stop", what="ra", value="stop") }}" method="post">
                                <button class="btn btn-danger btn-sm" type="submit" value="Stop">
                                    <i class="fas fa-fw fa-stop-circle"></i>
                                </button>
                            </form>
                        </div>
                    </td>
                </tr>
                <tr>
                    <th>Edit Server Setup</th>
                    <td>
                        <a href="{{ url_for("url.setup_ra") }}">
                            <button class="btn btn-info btn-sm" formmethod="post">
                                <i class="fas fa -fw fa-edit"></i>
                            </button>
                        </a>
                    </td>
                </tr>
                {% if not user %}
                    <tr>
                        <th>Delete RA</th>
                        <td>
                            <form action="{{ url_for("url.delete_ra", ra_id=row.id) }}" method="post">
                                <!--<input class="btn btn-danger btn-sm" type="submit" value="Delete!">-->
                                <button class="btn btn-danger btn-sm" type="submit">
                                    <i class="fas fa -fw fa-trash-alt"></i>
                                </button>
                            </form>
                        </td>
                    </tr>
                {% endif %}
            {% endfor %}
            </thead>
        </table>
    {% else %}
        <p>There was no Remote Access configuration done yet!</p>
    {% endif %}

    <h4>Users</h4>
    <hr>
    {% if user %}
        <table class="table small">
            <thead class="thead-dark">
            <tr>
                <th scope="col">User ID</th>
                <th scope="col">Time Created</th>
                <th scope="col">Username</th>
                <th scope="col">Firstname</th>
                <th scope="col">Surname</th>
                <th scope="col">Tunnel IP</th>
                <th scope="col">Public Key</th>
                <th scope="col">Keepalive</th>
                <th scope="col">WiFi-Password
                    <i class="fas fa -fw fa-wifi"></i>
                    <i class="fas fa -fw fa-key"></i>
                </th>
                <th scope="col">QR-Code</th>
                <th scope="col">Export Raspberry-Image</th>
                <th scope="col">Edit User</th>
                <th scope="col">Delete User</th>
            </tr>
            </thead>
            <tbody>
            {% for row in user %}
                <tr>
                    <td>{{ row.id }}</td>
                    <td>{{ row.time_created }}</td>
                    <td>{{ row.username }}</td>
                    <td>{{ row.firstname }}</td>
                    <td>{{ row.surname }}</td>
                    <td>{{ row.tunnel_cidr }}</td>
                    <td>{{ row.public_key }}</td>
                    <td>{{ row.keepalive }}</td>
                    <!-- Button trigger modal -->
                    <td>
                        <button class="btn btn-info btn-sm" data-toggle="modal"
                                data-password="{{ row.wifi_password }}"
                                data-target="#show_password">
                            <i class="fas fa-fw fa-eye"></i>
                        </button>
                    </td>
                    {% if ra_config %}

                        <td>
                            <a href="{{ url_for("url.qrcode_user", user_id=row.id) }}">
                                <button class="btn btn-info btn-sm" formmethod="post">
                                    <i class="fas fa -fw fa-qrcode"></i>
                                </button>
                            </a>
                        </td>
                    {% else %}
                        <td>
                            RA-Config missing
                        </td>
                    {% endif %}
                    {% if ra_config %}
                        <td>
                            <form action="{{ url_for("url.export_ra", user_id=row.id) }}" method="post">
                                <button class="btn btn-info btn-sm" type="submit">
                                    <i class="fas fa -fw fa-file-export"></i>
                                </button>
                            </form>
                        </td>
                    {% else %}
                        <td>
                            RA-Config missing
                        </td>
                    {% endif %}
                    <td>
                        <a href="{{ url_for("url.edit_user", user_id=row.id) }}">
                            <button class="btn btn-info btn-sm" formmethod="post">
                                <i class="fas fa -fw fa-user-edit"></i>
                            </button>
                        </a>
                    </td>
                    <td>
                        <form action="{{ url_for("url.delete_user", user_id=row.id) }}" method="post">
                            <button class="btn btn-danger btn-sm" type="submit">
                                <i class="fas fa -fw fa-trash-alt"></i>
                            </button>
                        </form>
                    </td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    {% else %}
        <p>There was no User configuration done yet!</p>
    {% endif %}

    <!-- Modal -->
    <div class="modal fade" id="show_password" tabindex="-1" role="dialog" aria-labelledby="showpasswordLabel"
         aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">WiFi-Password</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>Your Wi-Fi Password is:</p>
                    <span id="showpasswordLabel"></span>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
